[v3,1/1] devtools: test 32-bit build

Message ID 20201106165611.232288-1-thomas@monjalon.net (mailing list archive)
State Accepted, archived
Headers
Series [v3,1/1] devtools: test 32-bit build |

Checks

Context Check Description
ci/checkpatch warning coding style issues
ci/iol-broadcom-Performance success Performance Testing PASS
ci/iol-intel-Functional success Functional Testing PASS
ci/iol-broadcom-Functional success Functional Testing PASS
ci/iol-testing success Testing PASS
ci/iol-intel-Performance success Performance Testing PASS
ci/iol-mellanox-Performance success Performance Testing PASS

Commit Message

Thomas Monjalon Nov. 6, 2020, 4:56 p.m. UTC
  From: Bruce Richardson <bruce.richardson@intel.com>

It's reasonably common for patches to have issues when built on 32-bits, so
to prevent this, we can add a 32-bit build (if supported) to the
"test-meson-builds.sh" script. The tricky bit is using a valid
PKG_CONFIG_LIBDIR, so for now we use two common possibilities for where that
should point to in order to get a successful build.

Signed-off-by: Bruce Richardson <bruce.richardson@intel.com>
Signed-off-by: Thomas Monjalon <thomas@monjalon.net>
---
v3: unset override
    move and rename override
    split command in check_cc_flags
    use check_cc_flags for x86 default build
v2: added separate flag checking function
    added override of the DPDK_TARGET value
    added /usr/lib32 as possible 32-bit libdir
---
 devtools/test-meson-builds.sh | 32 +++++++++++++++++++++++++++++---
 1 file changed, 29 insertions(+), 3 deletions(-)
  

Comments

Bruce Richardson Nov. 6, 2020, 5:01 p.m. UTC | #1
On Fri, Nov 06, 2020 at 05:56:10PM +0100, Thomas Monjalon wrote:
> From: Bruce Richardson <bruce.richardson@intel.com>
> 
> It's reasonably common for patches to have issues when built on 32-bits, so
> to prevent this, we can add a 32-bit build (if supported) to the
> "test-meson-builds.sh" script. The tricky bit is using a valid
> PKG_CONFIG_LIBDIR, so for now we use two common possibilities for where that
> should point to in order to get a successful build.
> 
> Signed-off-by: Bruce Richardson <bruce.richardson@intel.com>
> Signed-off-by: Thomas Monjalon <thomas@monjalon.net>
> ---
> v3: unset override
>     move and rename override
>     split command in check_cc_flags
>     use check_cc_flags for x86 default build
> v2: added separate flag checking function
>     added override of the DPDK_TARGET value
>     added /usr/lib32 as possible 32-bit libdir
> ---
>  devtools/test-meson-builds.sh | 32 +++++++++++++++++++++++++++++---
>  1 file changed, 29 insertions(+), 3 deletions(-)
> 
> diff --git a/devtools/test-meson-builds.sh b/devtools/test-meson-builds.sh
> index a87de635a2..ac76c2184b 100755
> --- a/devtools/test-meson-builds.sh
> +++ b/devtools/test-meson-builds.sh
> @@ -43,6 +43,12 @@ default_cppflags=$CPPFLAGS
>  default_cflags=$CFLAGS
>  default_ldflags=$LDFLAGS
>  
> +check_cc_flags () # <flag to check> <flag2> ...
> +{
> +	echo 'int main(void) { return 0; }' |
> +	cc $@ -x c - -o /dev/null 2> /dev/null

Minor nit, as a continuation of the previous line, I think this should be
further indented.

Otherwise all looks good to me. Thanks for the updated changes.

/Bruce
  
Thomas Monjalon Nov. 6, 2020, 5:11 p.m. UTC | #2
06/11/2020 18:01, Bruce Richardson:
> On Fri, Nov 06, 2020 at 05:56:10PM +0100, Thomas Monjalon wrote:
> > From: Bruce Richardson <bruce.richardson@intel.com>
> > 
> > It's reasonably common for patches to have issues when built on 32-bits, so
> > to prevent this, we can add a 32-bit build (if supported) to the
> > "test-meson-builds.sh" script. The tricky bit is using a valid
> > PKG_CONFIG_LIBDIR, so for now we use two common possibilities for where that
> > should point to in order to get a successful build.
> > 
> > Signed-off-by: Bruce Richardson <bruce.richardson@intel.com>
> > Signed-off-by: Thomas Monjalon <thomas@monjalon.net>
> > ---
> > v3: unset override
> >     move and rename override
> >     split command in check_cc_flags
> >     use check_cc_flags for x86 default build
> > v2: added separate flag checking function
> >     added override of the DPDK_TARGET value
> >     added /usr/lib32 as possible 32-bit libdir
> > ---
> >  devtools/test-meson-builds.sh | 32 +++++++++++++++++++++++++++++---
> >  1 file changed, 29 insertions(+), 3 deletions(-)
> > 
> > diff --git a/devtools/test-meson-builds.sh b/devtools/test-meson-builds.sh
> > index a87de635a2..ac76c2184b 100755
> > --- a/devtools/test-meson-builds.sh
> > +++ b/devtools/test-meson-builds.sh
> > @@ -43,6 +43,12 @@ default_cppflags=$CPPFLAGS
> >  default_cflags=$CFLAGS
> >  default_ldflags=$LDFLAGS
> >  
> > +check_cc_flags () # <flag to check> <flag2> ...
> > +{
> > +	echo 'int main(void) { return 0; }' |
> > +	cc $@ -x c - -o /dev/null 2> /dev/null
> 
> Minor nit, as a continuation of the previous line, I think this should be
> further indented.

In general I keep piped commands at the same level.
This is a matter of taste,
but I can see other piped commands indented in this file,
so I will indent this one as well.

> Otherwise all looks good to me. Thanks for the updated changes.

Then I will merge it with above change. I guess we won't get more reviews.
  
Thomas Monjalon Nov. 6, 2020, 5:30 p.m. UTC | #3
06/11/2020 18:11, Thomas Monjalon:
> 06/11/2020 18:01, Bruce Richardson:
> > On Fri, Nov 06, 2020 at 05:56:10PM +0100, Thomas Monjalon wrote:
> > > From: Bruce Richardson <bruce.richardson@intel.com>
> > > 
> > > It's reasonably common for patches to have issues when built on 32-bits, so
> > > to prevent this, we can add a 32-bit build (if supported) to the
> > > "test-meson-builds.sh" script. The tricky bit is using a valid
> > > PKG_CONFIG_LIBDIR, so for now we use two common possibilities for where that
> > > should point to in order to get a successful build.
> > > 
> > > Signed-off-by: Bruce Richardson <bruce.richardson@intel.com>
> > > Signed-off-by: Thomas Monjalon <thomas@monjalon.net>
> > > ---
> > > v3: unset override
> > >     move and rename override
> > >     split command in check_cc_flags
> > >     use check_cc_flags for x86 default build
> > > v2: added separate flag checking function
> > >     added override of the DPDK_TARGET value
> > >     added /usr/lib32 as possible 32-bit libdir
> > > ---
> > >  devtools/test-meson-builds.sh | 32 +++++++++++++++++++++++++++++---
> > >  1 file changed, 29 insertions(+), 3 deletions(-)
> > > 
> > > diff --git a/devtools/test-meson-builds.sh b/devtools/test-meson-builds.sh
> > > index a87de635a2..ac76c2184b 100755
> > > --- a/devtools/test-meson-builds.sh
> > > +++ b/devtools/test-meson-builds.sh
> > > @@ -43,6 +43,12 @@ default_cppflags=$CPPFLAGS
> > >  default_cflags=$CFLAGS
> > >  default_ldflags=$LDFLAGS
> > >  
> > > +check_cc_flags () # <flag to check> <flag2> ...
> > > +{
> > > +	echo 'int main(void) { return 0; }' |
> > > +	cc $@ -x c - -o /dev/null 2> /dev/null
> > 
> > Minor nit, as a continuation of the previous line, I think this should be
> > further indented.
> 
> In general I keep piped commands at the same level.
> This is a matter of taste,
> but I can see other piped commands indented in this file,
> so I will indent this one as well.
> 
> > Otherwise all looks good to me. Thanks for the updated changes.
> 
> Then I will merge it with above change. I guess we won't get more reviews.

Applied
  

Patch

diff --git a/devtools/test-meson-builds.sh b/devtools/test-meson-builds.sh
index a87de635a2..ac76c2184b 100755
--- a/devtools/test-meson-builds.sh
+++ b/devtools/test-meson-builds.sh
@@ -43,6 +43,12 @@  default_cppflags=$CPPFLAGS
 default_cflags=$CFLAGS
 default_ldflags=$LDFLAGS
 
+check_cc_flags () # <flag to check> <flag2> ...
+{
+	echo 'int main(void) { return 0; }' |
+	cc $@ -x c - -o /dev/null 2> /dev/null
+}
+
 load_env () # <target compiler>
 {
 	targetcc=$1
@@ -52,11 +58,14 @@  load_env () # <target compiler>
 	export CFLAGS=$default_cflags
 	export LDFLAGS=$default_ldflags
 	unset DPDK_MESON_OPTIONS
-	if command -v $targetcc >/dev/null 2>&1 ; then
+	if [ -n "$target_override" ] ; then
+		DPDK_TARGET=$target_override
+	elif command -v $targetcc >/dev/null 2>&1 ; then
 		DPDK_TARGET=$($targetcc -v 2>&1 | sed -n 's,^Target: ,,p')
 	else # toolchain not yet in PATH: its name should be enough
 		DPDK_TARGET=$targetcc
 	fi
+	echo "Using DPDK_TARGET $DPDK_TARGET"
 	# config input: $DPDK_TARGET
 	. $srcdir/devtools/load-devel-config
 	# config output: $DPDK_MESON_OPTIONS, $PATH, $PKG_CONFIG_PATH, etc
@@ -200,12 +209,29 @@  done
 # Set the install path for libraries to "lib" explicitly to prevent problems
 # with pkg-config prefixes if installed in "lib/x86_64-linux-gnu" later.
 default_machine='nehalem'
-ok=$(cc -march=$default_machine -E - < /dev/null > /dev/null 2>&1 || echo false)
-if [ "$ok" = "false" ] ; then
+if ! check_cc_flags "-march=$default_machine" ; then
 	default_machine='corei7'
 fi
 build build-x86-default cc -Dlibdir=lib -Dmachine=$default_machine $use_shared
 
+# 32-bit with default compiler
+if check_cc_flags '-m32' ; then
+	if [ -d '/usr/lib/i386-linux-gnu' ] ; then
+		# 32-bit pkgconfig on Debian/Ubuntu
+		export PKG_CONFIG_LIBDIR='/usr/lib/i386-linux-gnu/pkgconfig'
+	elif [ -d '/usr/lib32' ] ; then
+		# 32-bit pkgconfig on Arch
+		export PKG_CONFIG_LIBDIR='/usr/lib32/pkgconfig'
+	else
+		# 32-bit pkgconfig on RHEL/Fedora (lib vs lib64)
+		export PKG_CONFIG_LIBDIR='/usr/lib/pkgconfig'
+	fi
+	target_override='i386-pc-linux-gnu'
+	build build-32b cc -Dc_args='-m32' -Dc_link_args='-m32'
+	target_override=
+	unset PKG_CONFIG_LIBDIR
+fi
+
 # x86 MinGW
 build build-x86-mingw $srcdir/config/x86/cross-mingw -Dexamples=helloworld